
#include <Adafruit_NeoPixel.h>

#define PIN 6

// Parameter 1 = number of pixels in strip
// Parameter 2 = Arduino pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(150, PIN, NEO_GRB + NEO_KHZ800);

#define MAX_X 10
#define MAX_Y 15

byte maska[135]={
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,
   0,1,0,0,0,0,0,0,0,0,0,0,0,1,1,
   0,1,1,0,0,0,0,1,0,0,0,0,1,1,1,
   0,1,1,0,0,0,1,1,1,0,0,1,1,1,1,
   0,1,1,0,1,1,1,1,1,0,0,1,1,1,1,
   0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
   0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
   };
int colors[14][3]={{0,150,0},{0,255,0},
                   {100,255,0},{255,255,0},
                   {150,0,0},{255,0,0},
                   {255,0,100},{255,0,255},
                   {150,0,255},{0,0,255},
                   {0,0,150},{0,150,255},
                   {0,255,255},{0,255,100}
                   };
int offcolor=0;
unsigned long millis1=0;
// плохие светодиоды
int badleds[]={0,1,15,30};


//
#define msg7RESET 11
#define msg7Strobe 12
#define msg7DCout 0

int arr1[7]={0,0,0,0,0,0,0};


void setup() {
  Serial.begin(9600);
  pinMode(msg7RESET, OUTPUT);
  pinMode(msg7Strobe, OUTPUT);
  strip.begin();
  for(int i=0;i<135;i++)
    {
    correctstrip(i,0,0,0);
    }
  strip.show();
  Serial.println("oksetup");
  }



void loop() {
    digitalWrite(msg7RESET, HIGH);   // осуществляем сброс MSGEQ7
    delay(5);
    digitalWrite(msg7RESET, LOW);
 
    for (int x = 0; x < 7; x++){             // семь частот - семь стробирующих импульсов
        digitalWrite(msg7Strobe, LOW);
        delayMicroseconds(35);           // ждем установления значения 35 мкс
        int spectrumRead = analogRead(A0);      // считываем значение с аналогового входа
 
        int PWMvalue = map(spectrumRead, 0, 1024, 0, 255);  // преобразовываем диапазон 0-1024 к диапазону 0-255 для ШИМ
        setVals(x,PWMvalue);
        arr1[x]=spectrumRead;
         digitalWrite(msg7Strobe, HIGH);
    }
    for(int i=0;i<7;i++)
      {Serial.print(" ");Serial.print(arr1[i]);}
    Serial.println();

  strip.show();
  if(millis()-millis1>1000)
    {millis1=millis();offcolor=(offcolor+1)%7;
    }  
}
///// 
//удалить испорченные
void correctstrip(int place,int color1,int color2,int color3)
  {
  int offset=0;
  for(int i=0;i<sizeof(badleds)/2;i++)
    {if(place>badleds[i])
       offset++;
    }   
    
  ///
  for(int i=0;i<sizeof(badleds)/2;i++)
    {if(place==badleds[i])
       return;}

    strip.setPixelColor(place-offset,color1,color2,color3);  
  }
////********************************************************************
void setVals(int i,int value1)
  {
  for(int j=0;j<9;j++)
    {
    if(value1>=j*28)
       {
       correctstrip((9-j)*15+i*2+1,colors[((i+offcolor)%7)*2][0],colors[((i+offcolor)%7)*2][1],colors[((i+offcolor)%7)*2][2]);
       correctstrip((9-j)*15+i*2+2,colors[((i+offcolor)%7)*2+1][0],colors[((i+offcolor)%7)*2+1][1],colors[((i+offcolor)%7)*2+1][2]); 
       }
    else
      {
      correctstrip((9-j)*15+i*2+1,0,0,0);      
      correctstrip((9-j)*15+i*2+2,0,0,0);      
      }  
    }  
  }
